<?php

namespace Teknisa\FIN\Modules\ContaPagar\Services\RetornoDDA;

class LeitorCnabSantander{

    private $cnpjEmpresa;
    CONST ID_REGISTRO_HEADER = '0';
    CONST ID_REGISTRO_LOTE = '1';
    CONST ID_REGISTRO_TRANSACAO = '3';
    CONST ID_REGISTRO_TRAILLER_LOTE = '5';
    CONST ID_REGISTRO_TRAILLER = '9';

    CONST CODIGO_COMPENSACAO_SANTANDER = '033';
    CONST CPF = '1';
    CONST SEGMENTO_I = 'I';
    CONST SEGMENTO_G = 'G';

    protected $retornos = array();

    public function __construct($arquivo, $cdbanco){
        try {

            $this->cdbanco = $cdbanco;
            $this->arquivo = $arquivo;
            $this->existeBoleto = false;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getRetornos(){
        $boletos = array();
        $boletos = array_filter($this->retornos, function($item){
          return strtoupper($item->getTipoRegistro()) == self::SEGMENTO_G;
        });
        return $boletos;
    }

    public function leArquivo($nrorg)
    {
        try {
            foreach ($this->arquivo as $linha) {
                if($linha){
                    if (strlen($linha) > 0){
                        $this->retorno = new Retorno();

                        $tipoDeRegistroDoArquivo = substr($linha,7,1);
                        switch ($tipoDeRegistroDoArquivo) {
                            case(self::ID_REGISTRO_HEADER):
                                $this->leHeaderArquivo($linha);
                                break;
                            case(self::ID_REGISTRO_LOTE):
                                $this->leHeaderLote($linha);
                                break;
                            case(self::ID_REGISTRO_TRANSACAO):
                                $this->existeBoleto = 'S';
                                $this->leRegistroDetalhe($linha);
                                break;
                        }
                        $this->retornos[] = $this->retorno;
                    }
                }
            }
            if(!$this->existeBoleto){
                throw new Exception("Não há boletos no arquivo de retorno.", 1);
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    private function leHeaderArquivo($registro){
        $this->cnpjEmpresa = substr($registro, 18, 14);
    }

    private function leHeaderLote($registro){
        if ((substr($registro, 8, 1) == self::SEGMENTO_I) && (substr($registro, 0, 3) == self::CODIGO_COMPENSACAO_SANTANDER)){
            $this->retorno->setTipoRegistro(self::SEGMENTO_I);
            //$this->cnpjEmpresa = substr($registro, 19, 14);
        }
    }

    private function leRegistroDetalhe($registro){
        $codigoBanco = substr($registro, 0, 3);
        if ((substr($registro, 13, 1) == self::SEGMENTO_G) && ($codigoBanco == self::CODIGO_COMPENSACAO_SANTANDER)){
            $this->retorno->setTipoRegistro(self::SEGMENTO_G);
            $valorTitulo = floatVal(substr($registro, 115, 15))/100;
            $this->retorno->setVrfinalbpag($valorTitulo); //VALOR NOMINAL DO TÍTULO
            $dtvencimento = substr($registro, 107, 2) . '/' . substr($registro, 109, 2) . '/' . substr($registro, 111, 4);
            $this->retorno->setDtvencimento($dtvencimento);//DATA DE VENCIMENTO DO TÍTULO
            //pos 18 a 61 codigo do banco + Moeda + Codigo DAC + Fator de Vencimento+ Valor Titulo no CB + Campo Livre
            $this->retorno->setCdbarrapag(substr($registro, 17, 44));
            $tipoInscricaoCedente = substr($registro, 61, 1);
            $this->retorno->tipoInscricao = ($tipoInscricaoCedente == self::CPF) ? 'F' : 'J';
            $this->retorno->setCdforneced(substr($registro, 63, 14));
            $this->retorno->setNmforneced(substr($registro, 77, 30));
            $this->retorno->setNrnotafisc(substr($registro, 147, 15));
            $this->retorno->setCnpjEmpresa($this->cnpjEmpresa);
            $this->retorno->setCodigoBanco(self::CODIGO_COMPENSACAO_SANTANDER);
        }
    }
}