<?php

namespace Teknisa\FIN\Modules\ContaReceber\Controllers;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO\Request\Row as Row;
use Teknisa\Libs\Service\CRUD as CrudService;
use Zeedhi\Framework\DTO\Request\DataSet as Data;
use Teknisa\FIN\Modules\ContaReceber\Services\EnvioAutomaticoService;

/**
 * Class EnvioAutomaticoController
 * @package Teknisa\FIN\Modules\ContaReceber\Controllers
 */
class EnvioAutomaticoController{
    
    protected $crudService;
    protected $parameterBag;
    protected $environment;
    protected $envioAutomaticoService;
    
    /**
     * @param CrudService            $crudService
     * @param ParameterBag           $parameterBag
     * @param Environment            $environment
     * @param EnvioAutomaticoService $envioAutomaticoService
     */
    public function __construct(CrudService $crudService, ParameterBag $parameterBag, Environment $environment, EnvioAutomaticoService $envioAutomaticoService){
        $this->crudService  = $crudService;
        $this->parameterBag = $parameterBag;
        $this->environment  = $environment;
        $this->envioAutomaticoService = $envioAutomaticoService;
    }

    /**
     * Envio Automático de Título por E-mail
     */
    public function envioAutomaticoTituloPorEmail(Row $request, Response $response){
        try {
            $row   = $request->getRow();
            
            $nrorg = $row['NRORG'];
            
            // Envio Automático de Título por E-mail
            $this->envioAutomaticoService->envioAutomaticoTituloPorEmail($nrorg, $request, $response);
        } catch (\Exception $e) {
            echo $e->getMessage();
        }
    }

    /**
     * Envio Automático de Carta de Cobrança por E-mail
     */
    public function envioAutomaticoCartaCobrancaPorEmail(Row $request, Response $response){
        try {
            $row   = $request->getRow();
            
            $nrorg = $row['NRORG'];
            
            // Envio Automático de Carta de Cobrança por E-mail
            $this->envioAutomaticoService->envioAutomaticoCartaCobrancaPorEmail($nrorg);
        } catch (\Exception $e) {
            echo $e->getMessage();
        }
    }
    
}