<?php

namespace Teknisa\FIN\Modules\MovimentacaoBancaria\Services;

use Teknisa\FIN\Modules\MovimentacaoBancaria\Factories\Bco54500ConciliacaoFactory;
use Teknisa\Model\Financeiro\Entities\Concimovbanc;

class Bco54500ConciliacaoManualService {

    protected $newCode;
    protected $entityManager;
    protected $factory;
    public function __construct($newCode, $entityManager, Bco54500ConciliacaoFactory $factory){
    	$this->newCode = $newCode;
        $this->entityManager = $entityManager;
        $this->factory = $factory;
    }

    public function updateMovreal($statusConciliacao, $formaConciliacao, $nrconcimovb,
                                                $cdsequextr, $nrseqmovreal, $cdreducont, $nrorg, $nrmovbare){
        $movreal = $this->factory->updateMovreal($statusConciliacao, $formaConciliacao, $nrconcimovb, $cdsequextr,
            $nrseqmovreal, $cdreducont, $nrorg, $nrmovbare);
        $this->entityManager->persist($movreal);
    }

    public function updateMovbancario($statusConciliacao, $formaConciliacao, $nrconcimovb, $nrmovbanc,
                                                $cdreducont, $nrorg, $cdsequexba, $nrseqmovreba){
        $movbancario = $this->factory->updateMovbancario($statusConciliacao, $formaConciliacao, $nrconcimovb, $nrmovbanc,
            $cdreducont, $nrorg, $cdsequexba, $nrseqmovreba);
        $this->entityManager->persist($movbancario);
    }

    public function insereConcimovbanc($cdreducont, $nrorg, $nrconcimovb){
        $concimovbanc = $this->factory->insereConcimovbanc($cdreducont, $nrorg, $nrconcimovb);
        $this->entityManager->persist($concimovbanc);
    }

    public function deleteConcimovbanc($cdreducont, $nrorg, $nrconcimovb){
        $concimovbanc = $this->factory->getConcimovbanc($cdreducont, $nrorg, $nrconcimovb);
        if ($concimovbanc instanceof Concimovbanc) {
            $this->entityManager->remove($concimovbanc);
        }
    }

    public function getSaldoContaCorr($cdreducont, $datarefe){
        $saldoContaCorr = $this->factory->getSaldoContaCorr($cdreducont, $datarefe);
        return $saldoContaCorr;
    }
}
